package supermercati_con_vettori;

public class ProdottoSupermercato extends Prodotto{

	private static int progressivo = 1;
	
	private int sconto;

	public ProdottoSupermercato(){
		this("",0,0,0);
	}
	
	public ProdottoSupermercato(String descr, float cost, int n, int s){
		super("SM-"+progressivo++,descr,cost,n);
		this.sconto = s;
	}
	
	// metodo della sola classe figlia
	// se richiamato per un prodotto del vettore dei prodotti in uno scontrino
	//  necessario l'uso di instanceof e del downcast a ProdottoSupermercato
	// Notare che, se questo metodo riscrivesse il metodo getSconto() ereditato
	// dal padre, grazie al binding dinamico, non sarebbe necessario l'uso di 
	// instanceof n del downcast
	public double getCostoScontato() {
		return costo*(100-sconto)/100;
	}
	
	// metodo ridefinito rispetto alla classe Prodotto
	public String toString() {
		String s = super.toString();
		s += "Sconto per promozioni: " + sconto + "%\n";
		return s;
	}

}
