package supermercati_con_vettori;

public class Scontrino{
	
	private static final int MAX_PRODOTTI = 100;
	
	private String codiceScontrino;
	private int codiceCliente;
	private Prodotto[] prodotti;
	private int numProdotti; // contiene il numero di prodotti presenti nel vettore
	private double importo;
	
	public Scontrino(){
		this("",0,new Prodotto[MAX_PRODOTTI],0,0);
	}
	
	public Scontrino(String codS, int codC, Prodotto[] prodotti, int n, double importo){
		this.codiceScontrino = codS;
		this.codiceCliente = codC;
		this.prodotti = prodotti;
		this.numProdotti = n;
		this.importo = importo;
	}
	
	public int getCodiceCliente() {
		return codiceCliente;
	}
	
	public Prodotto[] getProdotti() {
		return prodotti;
	}
	
	public int getNumProdotti() {
		return numProdotti;
	}
	
	
	// punto 1)
	public boolean aggiungiProdotto(Prodotto p) {
		boolean aggiunto = false;
		if(numProdotti < MAX_PRODOTTI) {
			prodotti[numProdotti++] = p;
			// se nella classe ProdottoSupermercato venisse riscritto il metodo
			// getCosto() in modo da restituire il costo scontato, l'if seguente
			// non sarebbe necessario e sarebbe sufficiente l'istruzione:
			// importo += p.getCosto() senza differenziazione sul tipo di prodotto
			// (questo grazie al binding dinamico)
			if(p instanceof ProdottoSupermercato)
				importo += ((ProdottoSupermercato)p).getCostoScontato();
			else
				importo += p.getCosto();
			aggiunto = true;
		}
		return aggiunto;
	}
	
    // punto 2)
	public int calcolaPunti(){
		int totPunti = 0;	
		for(int i=0; i<numProdotti; i++)
			totPunti += prodotti[i].getPunti();
		return totPunti;
	}
	
	
}
