package supermercati_con_vettori;

public class Supermercato {
	
	private static final int MAX_CLIENTI = 10000;
	private static final int MAX_SCONTRINI = 50000;
	
	private Cliente[] clienti;
	private int numClienti; // contiene il numero di clienti presenti nel vettore
	private Scontrino[] scontrini;
	private int numScontrini; // contiene il numero di scontrini presenti nel vettore
	
	public Supermercato(){
		this(new Cliente[MAX_CLIENTI],0,new Scontrino[MAX_SCONTRINI],0);
	}
	
	public Supermercato(Cliente[] c, int numC, Scontrino[] s, int numS){
		this.clienti = c;
		this.numClienti = numC;
		this.scontrini = s;
		this.numScontrini = numS;
	}
	
	// punto 3)
	public int numScontriniPerCliente(int codiceCard) {
		int numS = 0;
		for(int i=0; i < numScontrini; i++)
			if(scontrini[i].getCodiceCliente() == codiceCard)
				numS++;
		return numS;
	}
		
	
	// punto 4)
	public void aggiornaPuntiCliente(Scontrino s){
		int puntiDaAggiungere = s.calcolaPunti();
		boolean trovato=false;
		for(int i=0; i<numClienti && !trovato; i++)
			if(clienti[i].getCodiceFC()==s.getCodiceCliente()){
				trovato=true;
				clienti[i].aggiungiPunti(puntiDaAggiungere);
			}
		if(!trovato)
			System.out.println("Errore: cliente non trovato!\n");
	}
	
	
	// punto 5)
	public Cliente[] clientiPiuFedeli(){
		Cliente[] clientiFedeli;
		int numClientiPiuFedeli = 0, maxPunti = 0;
		// determiniamo quanti clienti hanno il maggior numero di punti, 
		// cos da sapere quanto dovr essere grande il vettore da restituire
		for(int i=0; i<numClienti; i++){
			if(clienti[i].getPunti() > maxPunti){
				// c' un nuovo numero massimo di punti
				maxPunti = clienti[i].getPunti(); // aggiorno il numero massimo
				numClientiPiuFedeli = 1; // questo  l'unico cliente avente il massimo (per ora)
			}
			else if(clienti[i].getPunti() == maxPunti)
				// il cliente corrente  un altro cliente che ha lo stesso numero massimo di punti
				numClientiPiuFedeli++; // incremento di una unit il numero di clienti aventi il massimo dei punti 
		}
		// creo il nuovo vettore che conterr solo i clienti con il massimo numero di punti.
		// il numero di tali clienti  numClientiPiuFedeli
		clientiFedeli = new Cliente[numClientiPiuFedeli];
		int j=0; // indice di scorrimento del vettore dei clienti pi fedeli
		for(int i=0; i<numClienti; i++)
			if(clienti[i].getPunti() ==  maxPunti) // individuo i clienti con il massimo numero di punti
				clientiFedeli[j++] = clienti[i]; // inserisco il cliente nel vettore dei clienti fedeli e 
												// aggiorno l'indice di scorrimento del vettore dei 
												//clienti pi fedeli
		return clientiFedeli;
	}

}
